﻿using System;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace Post8652
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.MapUnit = GeographyUnit.Meter;
                Map1.CurrentExtent = new RectangleShape(870317.97554194, 6539689.3866238, 871034.57268198, 6539211.6551972);

                Map1.MapTools.OverlaySwitcher.Enabled = true;
                Map1.MapTools.MouseCoordinate.Enabled = true;

                Proj4Projection proj4 = new Proj4Projection();
                proj4.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(25832);
                proj4.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();

                PointShape originalPoint = new PointShape(416509.010974, 5598779.924175);
                proj4.Open();
                PointShape pointGoogle = proj4.ConvertToExternalProjection(originalPoint) as PointShape;
                proj4.Close();

                WebImage webImage = new WebImage("./red_point.gif");

                //you can set the offset value you want
                webImage.ImageOffsetX = -1;
                webImage.ImageOffsetY = -1;

                InMemoryMarkerOverlay markerOverlay = new InMemoryMarkerOverlay("MarkerOverlay");
                markerOverlay.Features.Add(new Feature(pointGoogle));
                markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage = webImage;
                markerOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                InMemoryFeatureLayer featureLayer = new InMemoryFeatureLayer();
                featureLayer.InternalFeatures.Add(new Feature(pointGoogle));
                featureLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.City1;
                featureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                LayerOverlay overlay = new LayerOverlay("FeatureOverlay");
                overlay.IsBaseOverlay = false;
                overlay.Layers.Add(featureLayer);

                GoogleOverlay google = new GoogleOverlay("Google Map");

                Map1.CustomOverlays.Add(google);
                Map1.CustomOverlays.Add(overlay);
                Map1.CustomOverlays.Add(markerOverlay);
            }
        }
    }
}
